#/bin/sh

if [ $# == 1 ]; then

case $1 in
install|--install|-i )

sudo  apt-get -y install bridge-utils hostapd dnsmasq
echo "######################################################################"
echo "Souhaitez-vous compiler la version de hostapd pour la clé edimax?[o|n]"
read rep
if [ $rep == "o"]; then
unzip 0001-RTL8188C_8192C_USB_linux_v4.0.2_9000.20130912.zip
cd RTL8188C_8192C_USB_linux_v4.0.2_9000.20130911/wpa_supplicant_hostapd/
tar -xzvf wpa_supplicant_hostapd-0.8_rtw_r7475.20130812.tar.gz
cd wpa_supplicant_hostapd-0.8_rtw_r7475.20130812/hostapd
make
sudo make install
fi
echo "######################################################################" 
echo "Donner le nom du reseau wifi que vous souhaitez creer [mathixdudu]:"
read nom
if [$nom == ""]; then
 nom="mathixdudu"
 echo "Nom du réseau choisi : $nom"
fi
echo "######################################################################" 
echo "Donner le mot du passe du reseau wifi que vous souhaitez creer [mathixdudu]:"
read  mdp
if [$mdp == ""]; then
 mdp='mathixdudu'
  echo "Mdp du réseau choisi : $mdp"
fi
echo "######################################################################" 
echo "Donner le driver de la cle wifi utilisee [rtl871xdrv]:"
read  driver
if [$driver == ""]; then
 driver='rtl871xdrv'
 echo "driver choisi : $driver"
fi

echo "######################################################################" 
echo "modification du fichier interfaces"
## backup des fichiers de configuration avant modification
sudo mv  /etc/network/interfaces  /etc/network/interfaces.backup
##creation du nouveau fichier interfaces
echo "auto lo
iface lo inet loopback

auto eth0
allow-hotplug eth0
iface eth0 inet dhcp

# si besoin de faire un pont avec la connexion filaire
auto br0
iface br0 inet dhcp
bridge_ports eth0 wlan0

auto wlan0
allow-hotplug wlan0
iface wlan0 inet static
address 10.0.0.1
netmask 255.255.255.0

up iptables-restore </etc/iptables.ipv4.nat
"| sudo  tee /etc/network/interfaces

echo "######################################################################" 
echo "modification des règles de iptables"
sudo iptables -t nat -A POSTROUTING -o eth0 -j MASQUERADE
sudo iptables -A FORWARD -i eth0 -o wlan0 -m state --state RELATED,ESTABLISHED -j ACCEPT
sudo iptables -A FORWARD -i wlan0 -o eth0  -j ACCEPT
sudo sh -c "iptables-save > /etc/iptables.ipv4.nat"

echo "######################################################################" 
echo "autorisation du forwarding"
##sauvegarde du fichier
sudo cp /etc/sysctl.conf /etc/sysctl.conf.backup
##autorisation du forwarding
echo "net.ipv4.ip_forward=1" | sudo tee -a /etc/sysctl.conf

echo "######################################################################" 
echo "modification du dnsmasq"
##sauvegarde du dnsmasq
sudo cp /etc/dnsmasq.conf /etc/dnsmasq.conf.backup

#modification du dnsmasq
echo "interface=wlan0
dhcp-range=10.0.0.100,10.0.0.200,255.255.255.0,12h" |sudo tee -a /etc/dnsmasq.conf
echo "######################################################################" 
echo "modification du hostapd"
#sauvegarde du hostapd.conf
sudo mv  /etc/hostapd/hostapd.conf  /etc/hostapd/hostapd.conf.backup

#modification
echo "interface=wlan0
driver=rtl871xdrv
bridge=br0
#nom du wifi
ssid=$nom
channel=1
wmm_enabled=0
wpa=1
#mot de passe du wifi
wpa_passphrase=$mdp
wpa_key_mgmt=WPA-PSK
wpa_pairwise=TKIP
rsn_pairwise=CCMP
auth_algs=1
macaddr_acl=0" | sudo tee /etc/hostapd/hostapd.conf
echo "######################################################################" 
echo "Installation terminée. Vous pouvez redemarrer le raspberry pi en faisant 'sudo reboot'";;

backup)
sudo mv  /etc/network/interfaces.backup  /etc/network/interfaces
sudo mv  /etc/hostapd/hostapd.conf.backup  /etc/hostapd/hostapd.conf
sudo mv  /etc/sysctl.conf.backup  /etc/sysctl.conf
sudo mv /etc/dnsmasq.conf.backup /etc/dnsmasq.conf
sudo rm  /etc/iptables.ipv4.nat
echo "######################################################################" 
echo "Backup Terminé";;

esac
else
echo "Il faut un argument : install ou backup"
fi
exit 0
